Log4j 1.2.7

## org.apache.log4j.net
Class SocketHubAppender

    java.lang.Object
      |
      +--org.apache.log4j.AppenderSkeleton
            |
            +--org.apache.log4j.net.SocketHubAppender

All Implemented Interfaces:
  Appender, OptionHandler

public class SocketHubAppender
extends AppenderSkeleton

Sends `LoggingEvent` objects to a set of remote log servers, usually a `SocketNodes`.

Acts just like `SocketAppender` except that instead of connecting to a given remote log server, `SocketHubAppender` accepts connections from the remote log servers as clients. It can accept more than one connection. When a log event is received, the event is sent to the set of currently connected remote log servers. Implemented this way it does not require any update to the configuration file to send data to another remote log server. The remote log server simply connects to the host and port the `SocketHubAppender` is running on.

The `SocketHubAppender` does not store events such that the remote side will events that arrived after the establishment of its connection. Once connected, events arrive in order as guaranteed by the TCP protocol.

This implementation borrows heavily from the `SocketAppender`.

The SocketHubAppender has the following characteristics:

- If sent to a `SocketNode`, logging is non-intrusive as far as the log event is concerned. In other words, the event will be logged with the same time stamp, `NDC`, location info as if it were logged locally.

- `SocketHubAppender` does not use a layout. It ships a serialized `LoggingEvent` object to the remote side.

- `SocketHubAppender` relies on the TCP protocol. Consequently, if the remote side is reachable, then log events will eventually arrive at remote client.

- If no remote clients are attached, the logging requests are simply dropped.

- Logging events are automatically buffered by the native TCP implementation. This means that if the link to remote client is slow but still faster than the rate of (log) event production, the application will not be affected by the slow network connection. However, if the network connection is slower then the rate of event production, then the local application can only progress at the network rate. In particular, if the network link to the the remote client is down, the application will be blocked.

  On the other hand, if the network link is up, but the remote client is down, the client will not be blocked when making log requests but the log events will be lost due to client unavailability.

  The single remote client case extends to multiple clients connections. The rate of logging will be determined by the slowest link.

- If the JVM hosting the `SocketHubAppender` exits before the `SocketHubAppender` is closed either explicitly or subsequent to garbage collection, then there might be untransmitted data in the pipe which might be lost. This is a common problem on Windows based systems.

  To avoid lost data, it is usually sufficient to `close()` the `SocketHubAppender` either explicitly or by calling the `LogManager.shutdown()` method before exiting the application.

Author:
  Mark Womack

Fields inherited from class org.apache.log4j.AppenderSkeleton
`closed, errorHandler, headFilter, layout, name, tailFilter, threshold`

Constructor Summary
`SocketHubAppender()`
`SocketHubAppender(int _port)` Connects to remote server at `address` and `port`.

Method Summary
`void` `activateOptions()` Set up the socket server on the specified port.
`void` `append(LoggingEvent event)` Append an event to all of current connections.
`void` `cleanUp()` Release the underlying ServerMonitor thread, and drop the connections to all connected remote servers.
`void` `close()` Close this appender.
`boolean` `getLocationInfo()` Returns value of the LocationInfo option.
`int` `getPort()` Returns value of the Port option.
`boolean` `requiresLayout()` The SocketHubAppender does not use a layout.
`void` `setLocationInfo(boolean _locationInfo)` The LocationInfo option takes a boolean value.
`void` `setPort(int _port)` The Port option takes a positive integer representing the port where the server is waiting for connections.

Methods inherited from class org.apache.log4j.AppenderSkeleton
`addFilter, clearFilters, doAppend, finalize, getErrorHandler, getFilter, getFirstFilter, getLayout, getName, getThreshold, isAsSevereAsThreshold, setErrorHandler, setLayout, setName, setThreshold`

Methods inherited from class java.lang.Object
`clone, equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### SocketHubAppender

    public SocketHubAppender()

### SocketHubAppender

    public SocketHubAppender(int _port)

  Connects to remote server at `address` and `port`.

Method Detail

### activateOptions

    public void activateOptions()

  Set up the socket server on the specified port.
  Overrides:
    `activateOptions` in class `AppenderSkeleton`

### close

    public void close()

  Close this appender.

  This will mark the appender as closed and call then `cleanUp()` method.

### cleanUp

    public void cleanUp()

  Release the underlying ServerMonitor thread, and drop the connections to all connected remote servers.

### append

    public void append(LoggingEvent event)

  Append an event to all of current connections.
  Overrides:
    `append` in class `AppenderSkeleton`

### requiresLayout

    public boolean requiresLayout()

  The SocketHubAppender does not use a layout. Hence, this method returns `false`.

### setPort

    public void setPort(int _port)

  The Port option takes a positive integer representing the port where the server is waiting for connections.

### getPort

    public int getPort()

  Returns value of the Port option.

### setLocationInfo

    public void setLocationInfo(boolean _locationInfo)

  The LocationInfo option takes a boolean value. If true, the information sent to the remote host will include location information. By default no location information is sent to the server.

### getLocationInfo

    public boolean getLocationInfo()

  Returns value of the LocationInfo option.

Log4j 1.2.7

Copyright 2000-2002 Apache Software Foundation.